using System;
using System.ComponentModel;
using System.Configuration;
using System.Collections;
using System.Collections.Generic;
using Eco.Persistence;


namespace ECO_ORMBattle_SimpleExample
{
	public partial class ECO_ORMBattle_SimpleExamplePMP : Eco.Persistence.PersistenceMapperProvider
	{
		#region Eco Managed Code
		private void DoGenerateDB()
		{
			if (PersistenceMapper is PersistenceMapperDb)
				(PersistenceMapper as PersistenceMapperDb).CreateDataBaseSchema(GetTypeSystemService(true), new DefaultCleanPsConfig(true));
			else
				throw new InvalidOperationException("The PersistenceMapper is not a PersistenceMapperDb");
		}
		/// <summary>
		/// Returns the singleton instance of the PersistenceMapperProvider.
		/// </summary>
		public static ECO_ORMBattle_SimpleExamplePMP Instance
		{
			get
			{
				return GetInstance<ECO_ORMBattle_SimpleExamplePMP>();
			}
		}
		#endregion

		public ECO_ORMBattle_SimpleExamplePMP(): base()
		{
			InitializeComponent();

            LoadConnectionString();
		}

		/// <summary>
		/// Regenerates the database schema, no questions asked.
		/// </summary>
		public static void GenerateDB()
		{
			Instance.DoGenerateDB();
		}

        protected void LoadConnectionString()
        {
            // TODO
            // Load the connection string for the database from the config file.
            ConnectionStringSettingsCollection cssc = ConfigurationManager.ConnectionStrings;
            if (cssc != null)
            {
                ConnectionStringSettings css = cssc["DevGroupBattle"];
                if (css != null)
                {
                    // If this Connection String Exists, use it instead of the default
                    sqlConnection1.ConnectionString = css.ConnectionString;
                }
            }
            else
                throw new ArgumentNullException("cssc");
        }

		#region EcoSpace type reference
		// this field is here to ensure that the 
		// ecospace type is removed by the optimization in the compiler
		// if you rename your ecospace, please update this reference too.
		protected Type ecoTypeSpaceReference = typeof(ECO_ORMBattle_SimpleExample.ECO_ORMBattle_SimpleExampleEcoSpace);
		#endregion
	}
}